import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import React from 'react';

function noop() {}

var FoundationAsyncButtonGroupContext = /*#__PURE__*/React.createContext({
  enable: noop,
  disable: noop,
  disabled: false
});
export function FoundationAsyncButtonGroupProvider(_ref) {
  var children = _ref.children;

  var _React$useState = React.useState(false),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      disabled = _React$useState2[0],
      setDisabled = _React$useState2[1];

  var enable = React.useCallback(function () {
    setDisabled(false);
  }, []);
  var disable = React.useCallback(function () {
    setDisabled(true);
  }, []);
  var context = React.useMemo(function () {
    return {
      enable: enable,
      disable: disable,
      disabled: disabled
    };
  }, [enable, disable, disabled]);
  return /*#__PURE__*/React.createElement(FoundationAsyncButtonGroupContext.Provider, {
    value: context
  }, children);
}
export function FoundationAsyncButtonGroupConsumer(_ref2) {
  var children = _ref2.children;
  return /*#__PURE__*/React.createElement(FoundationAsyncButtonGroupContext.Consumer, null, function (context) {
    return children(context);
  });
}
export function useAsyncButtonGroup() {
  return React.useContext(FoundationAsyncButtonGroupContext);
}
//# sourceMappingURL=FoundationAsyncButtonGroupContext.js.map