import React from 'react';
import purebem from 'purebem';
import FoundationButtonSpinner from './FoundationButtonSpinner';
import './FoundationButton.scss';

function noop() {}

export default /*#__PURE__*/React.forwardRef(function FoundationButton(_ref, ref) {
  var _ref$autoFocus = _ref.autoFocus,
      autoFocus = _ref$autoFocus === void 0 ? false : _ref$autoFocus,
      children = _ref.children,
      _ref$disabled = _ref.disabled,
      disabled = _ref$disabled === void 0 ? false : _ref$disabled,
      _ref$loading = _ref.loading,
      loading = _ref$loading === void 0 ? false : _ref$loading,
      _ref$onClick = _ref.onClick,
      onClick = _ref$onClick === void 0 ? noop : _ref$onClick,
      _ref$toggled = _ref.toggled,
      toggled = _ref$toggled === void 0 ? false : _ref$toggled,
      _ref$type = _ref.type,
      type = _ref$type === void 0 ? 'button' : _ref$type,
      _ref$ui = _ref.ui,
      ui = _ref$ui === void 0 ? 'gray' : _ref$ui;
  var block = purebem('foundation-button');
  var buttonRef = React.useRef(null);
  React.useImperativeHandle(ref, function () {
    return {
      focus: function focus() {
        if (buttonRef.current !== null) {
          buttonRef.current.focus();
        }
      }
    };
  });
  return /*#__PURE__*/React.createElement("button", {
    autoFocus: autoFocus,
    className: block({
      disabled: disabled || loading,
      loading: loading,
      toggled: toggled,
      ui: ui
    }),
    disabled: disabled || loading,
    onClick: onClick,
    ref: buttonRef,
    type: type
  }, /*#__PURE__*/React.createElement("div", {
    className: block('content', {
      loading: loading
    })
  }, children), /*#__PURE__*/React.createElement(FoundationButtonSpinner, {
    visible: loading
  }));
});
//# sourceMappingURL=FoundationButton.js.map