/// <reference types="react" />
export interface FoundationButtonClickHandler {
    (evt: React.MouseEvent<HTMLButtonElement>): void;
}
export interface FoundationLinkButtonClickHandler {
    (evt: React.MouseEvent<HTMLAnchorElement>): void;
}
export declare type FoundationButtonType = 'button' | 'reset' | 'submit';
export declare type FoundationButtonUI = 'blue' | 'gray' | 'link' | 'red' | 'purple';
export declare type FoundationLinkButtonUI = FoundationButtonUI;
export interface FoundationButtonRef {
    focus: () => void;
}
export interface FoundationButtonProps {
    autoFocus?: boolean;
    children: React.ReactNode;
    disabled?: boolean;
    loading?: boolean;
    onClick?: FoundationButtonClickHandler;
    toggled?: boolean;
    type?: FoundationButtonType;
    ui?: FoundationButtonUI;
}
export interface FoundationButtonSpinnerProps {
    visible: boolean;
}
export interface FoundationLinkButtonProps {
    children: React.ReactNode;
    disabled?: boolean;
    href: string;
    onClick?: FoundationLinkButtonClickHandler;
    target?: string;
    toggled?: boolean;
    ui?: FoundationLinkButtonUI;
}
export interface FoundationAsyncButtonProps<T, U> {
    asyncAction: () => Promise<T>;
    autoFocus?: boolean;
    children: React.ReactNode;
    disabled?: boolean;
    onAsync?: () => void;
    onAsyncActionSuccess?: (data: T) => void;
    onAsyncActionError?: (e: U) => void;
    ui?: FoundationButtonUI;
}
export interface FoundationAsyncButtonGroupProps {
    children: React.ReactNode;
}
export interface FoundationAsyncButtonGroupContextType {
    enable: () => void;
    disable: () => void;
    disabled: boolean;
}
export interface FoundationAsyncButtonGroupProviderProps {
    children: React.ReactNode;
}
export interface FoundationAsyncButtonGroupConsumerProps {
    children: (context: FoundationAsyncButtonGroupContextType) => React.ReactElement | null;
}
